/**
 # connect-four.js
 # Connect4 game -Creates/provides interfaces to play game 
 #
 # @author Joachim Schmidt - joachim.schmidt@jschmidt-systemberatung.de
 # @copyright Copyright (C) 2022 Joachim Schmidt. All rights reserved.
 # @license	 http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 #
 # change activity:
 */ 
 function Game(){this.rows=6,this.columns=7,this.status=0,this.depth=5,this.score=1e5,this.round=0,this.winning_array=[],this.iterations=0,this.draws=0,this.moves=[],this.winmarked=!1,that=this,that.init(),jQuery("#undo-move").hide()}function Start(){window.Game=new Game,jQuery("td").hover(function(){jQuery(this).parents("table").find("col:eq("+jQuery(this).index()+")").toggleClass("hover")})}Game.prototype.init=function(){for(var b=new Array(that.rows),a=0;a<b.length;a++){b[a]=new Array(that.columns);for(var c=0;c<b[a].length;c++)b[a][c]=null}this.board=new Board(this,b,0);for(var b="<col/><col/><col/><col/><col/><col/><col/>",a=0;a<that.rows;a++){b+="<tr>";for(var c=0;c<that.columns;c++)b+="<td class='empty'></td>";b+="</tr>"}document.getElementById("game_board").innerHTML=b;for(var d=document.getElementById("game_board").getElementsByTagName("td"),a=0;a<d.length;a++)d[a].addEventListener?d[a].addEventListener("click",that.act,!1):d[a].attachEvent&&d[a].attachEvent("click",that.act);that.startMessage()},Game.prototype.act=function(a){var b=a.target||window.event.srcElement;jQuery("#coin").is(":animated")||0==that.round&&that.place(b.cellIndex)},Game.prototype.startMessage=function(){var a=document.getElementById("status"),b="Game started ";"de"==document.getElementById("lang").lang&&(b="Spiel gestartet"),a.className="status-running",a.innerHTML=b},Game.prototype.place=function(b){if(that.board.score()!=that.score&&that.board.score()!= -that.score&&!that.board.isFull()){for(var e=new Array,a=that.rows-1;a>=0;a--)if("empty"==document.getElementById("game_board").rows[a].cells[b].className){if(1==that.round){var c=51*b,d=51*a;jQuery("#coin").attr("class","cpu-coin").css({left:c}).fadeIn("fast").animate({top:d+"px"},700,"easeOutBounce",function(){if(document.getElementById("game_board").rows[a].cells[b].className="coin cpu-coin",jQuery("#coin").hide().css({top:"0px"}),!that.board.place(b))return alert("Invalid move1! row = "+a+"column = "+b);that.round=that.switchRound(that.round),e=[a,b],that.moves.push(e),that.updateStatus()})}else{var c=51*b,d=51*a;jQuery("#coin").attr("class","human-coin").css({left:c}).fadeIn("fast").animate({top:d+"px"},700,"easeOutBounce",function(){if(document.getElementById("game_board").rows[a].cells[b].className="coin human-coin",jQuery("#coin").hide().css({top:"0px"}),that.generateComputerDecision(),!that.board.place(b))return alert("Invalid move2! row = "+a+" column = "+b);that.round=that.switchRound(that.round),e=[a,b],that.moves.push(e),that.updateStatus()})}break}}},Game.prototype.undoMove=function(){if(!(that.moves.length<1)){for(var a=0;a<2;a++){var b=that.moves.pop(),c=b[0],d=b[1];document.getElementById("game_board").rows[c].cells[d].className="empty",this.board.field[c][d]=null}that.winmarked&&that.unmarkWin(),that.updateCheckboard(),that.updateStatus()}},Game.prototype.generateComputerDecision=function(){that.board.score()==that.score||that.board.score()== -that.score||that.board.isFull()||setTimeout(function(){var a=document.getElementById("difficulty");maxDepth=a.options[a.selectedIndex].value;var b=aiMove();that.updateCheckboard(),that.draws++,that.place(b)},100)},Game.prototype.switchRound=function(a){return 0==a?1:0},Game.prototype.updateStatus=function(){that.status=0,that.board.isFull()&&(that.status=3),that.board.score()== -that.score&&(that.status=1,that.markWin()),that.board.score()==that.score&&(that.status=2,that.markWin());var b="you have won",c="you have lost",d="it was a draw",e="Game running";"de"==document.getElementById("lang").lang&&(b="du hast gewonnen",c="du hast verloren",d="unentschieden",e="Spiel l&auml;uft");var a=document.getElementById("status");0==that.status?(a.className="status-running",a.innerHTML=e,that.updateCheckboard(),that.moves.length>1?jQuery("#undo-move").show():jQuery("#undo-move").hide()):1==that.status?(a.className="status-won",a.innerHTML=b,this.moves=[],jQuery("#undo-move").hide()):2==that.status?(a.className="status-lost",a.innerHTML=c):(a.className="status-tie",a.innerHTML=d)},Game.prototype.unmarkWin=function(){for(var a=0;a<6;a++)for(var b=0;b<7;b++)"coin cpu-coin win"==document.getElementById("game_board").rows[a].cells[b].className&&(document.getElementById("game_board").rows[a].cells[b].className="coin cpu-coin");that.winmarked=!1},Game.prototype.markWin=function(){for(var a=0;a<that.winning_array.length;a++){var b=document.getElementById("game_board").rows[that.winning_array[a][0]].cells[that.winning_array[a][1]].className;document.getElementById("game_board").rows[that.winning_array[a][0]].cells[that.winning_array[a][1]].className=b+" win"}that.winmarked=!0},Game.prototype.restartGame=function(){var a=document.getElementById("difficulty"),b=a.options[a.selectedIndex].value;that.depth=b,maxDepth=b,that.status=0,that.round=0,that.init(),that.draws=0,that.moves=[],that.resetCheckboard(),that.updateStatus(),that.startMessage(),jQuery("#undo-move").hide(),jQuery("td").hover(function(){jQuery(this).parents("table").find("col:eq("+jQuery(this).index()+")").toggleClass("hover")})},Game.prototype.logCheckboard=function(){for(var a=0;a<6;a++)console.log(checkboard[a])},Game.prototype.resetCheckboard=function(){for(var a=0;a<6;a++)for(var b=0;b<7;b++)checkboard[a][b]=""},Game.prototype.updateCheckboard=function(){for(var a=0;a<6;a++)for(var b=0;b<7;b++)"coin cpu-coin"==document.getElementById("game_board").rows[a].cells[b].className?checkboard[a][b]="b":"coin human-coin"==document.getElementById("game_board").rows[a].cells[b].className?checkboard[a][b]="r":checkboard[a][b]=""},window.onload=function(){Start()}